#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#define A320_BUTTON_UP              SDLK_UP
#define A320_BUTTON_DOWN            SDLK_DOWN
#define A320_BUTTON_LEFT            SDLK_LEFT
#define A320_BUTTON_RIGHT           SDLK_RIGHT
#define A320_BUTTON_A               SDLK_LCTRL
#define A320_BUTTON_B               SDLK_LALT
#define A320_BUTTON_X               SDLK_SPACE
#define A320_BUTTON_Y               SDLK_LSHIFT
#define A320_BUTTON_L               SDLK_TAB
#define A320_BUTTON_R               SDLK_BACKSPACE
#define A320_BUTTON_START           SDLK_RETURN
#define A320_BUTTON_SELECT          SDLK_ESCAPE
#define A320_BUTTON_POWUP           SDLK_PAUSE
#define A320_BUTTON_POWDOWN         SDLK_PAUSE

bool A320_ButtonPressed[14];


// Function prototypes
Bitu GetKeyCode(SDL_keysym keysym);


#define BASIC_COLORS      16
#define VIRT_KEYBOARD      2
#define VIRT_KEYBOARD_ROW  9
#define VIRT_KEYBOARD_COL 10

// Normal Keyboard Row
#define VIRT_ROW_SHIFTBACK 5
#define VIRT_ROW_LALTCTRL  6
#define VIRT_ROW_RALTCTRL  7

// Special Keyboard Row
#define VIRT_ROW_INSHOM    0
#define VIRT_ROW_DELEND    1
#define VIRT_ROW_PGUPGD    2
#define VIRT_ROW_ESCENTER  3
#define VIRT_ROW_TABPAUSE  4
#define VIRT_ROW_FUNCLABEL 5
#define VIRT_ROW_FUNC1_10  6
#define VIRT_ROW_FUNC1112  7
// Both Keyboard Row
#define VIRT_ROW_SPECIAL   8

//    0   1   2   3   4   5   6   7   8   9
char virt_keyboard[VIRT_KEYBOARD][VIRT_KEYBOARD_ROW][VIRT_KEYBOARD_COL] =
{
 { { '1','2','3','4','5','6','7','8','9','0' },
   { 'a','b','c','d','e','f','g','h','i','j' },
   { 'k','l','m','n','o','p','q','r','s','t' },
   { 'u','v','w','x','y','z',' ',' ',' ',0x27 },
   { '`','-','=','[',']',';',',','.','/','\\' },
   { 'S','H','F','T',' ','B','A','C','K',' ' },
   { 'L','A','L','T',' ','L','C','T','L',' ' },
   { 'R','A','L','T',' ','R','C','T','L',' ' },
   { 'S','P','E','C','A','L','K','E','Y','S' } },
 { { 'I','N','S',' ',' ','H','O','M','E',' ' },
   { 'D','E','L',' ',' ','E','N','D',' ',' ' },
   { 'P','G','U','P',' ','P','G','D','W','N' },
   { 'E','S','C',' ',' ','E','N','T','E','R' },
   { 'T','A','B',' ',' ','P','A','U','S','E' },
   { 'F','U','N','C',' ',' ','K','E','Y','S' },
   { '1','2','3','4','5','6','7','8','9','0' },
   { '1','1',' ',' ',' ','1','2',' ',' ',' ' },
   { 'N','O','R','M','A','L','K','E','Y','S' } }
};

int virt_cur_kbd = 0;
int virt_col_key = 0;
int virt_row_key = 0;
int fontcolorset = 0;
int fontcolor_front;
int fontcolor_back;
int fontcolor_frontsel;
int fontcolor_backsel;

                                        //   r    g    b
SDL_Color basic_colors[BASIC_COLORS] = { { 255, 255, 255, 0 },    //  0 = white
                                         {   0,   0,   0, 0 },    //  1 = black
                                         { 255,   0,   0, 0 },    //  2 = red
                                         {   0,   0, 255, 0 },    //  3 = blue
                                         {   0, 255,   0, 0 },    //  4 = green
                                         { 255, 255,   0, 0 },    //  5 = yellow
                                         {   0, 255, 255, 0 },    //  6 = cyan
                                         { 255,   0, 127, 0 },    //  7 = pink
                                         { 255, 127,   0, 0 },    //  8 = orange
                                         {   0, 127, 127, 0 },    //  9 = dcyan
                                         {  63,  63,  63, 0 },    // 10 = grey
                                         { 191, 191, 191, 0 },    // 11 = ltgrey
                                         {   0,   0, 127, 0 },    // 12 = dkblue
                                         { 127,   0,   0, 0 },    // 13 = dkred
                                         {   0, 127,   0, 0 },    // 14 = dkgreen
                                         { 100,   0,   0, 0 } };  // 15 = use for transparent

bool virt_shift          = false;
bool virt_lalt           = false;
bool virt_lctrl          = false;
bool virt_ralt           = false;
bool virt_rctrl          = false;
bool virt_low_halfrow    = false;
bool virt_up_halfrow     = false;
bool virt_full_row       = false;

#define OSD_STATE_NOBUFFER 1
#define OSD_STATE_BUFFER   2
int virt_osd_bufferstate = OSD_STATE_NOBUFFER; // Use defined states above
bool virt_osd_debug     = false;
bool virt_osd_virtkey   = false;
bool virt_virtkey_press = false;
bool virt_vk_firstrun   = false;

void VIRT_LoadFont( int fontsize )
{
    if (sdl.font) TTF_CloseFont(sdl.font);

    sdl.font=TTF_OpenFont("dbfont.ttf", fontsize );
    if (!sdl.font)  // Try again!
        sdl.font=TTF_OpenFont("../dbfont.ttf", fontsize );
#if 0
    if (!sdl.font)  // Try again!
        sdl.font=TTF_OpenFont("/usr/local/dosbox/dbfont.ttf", fontsize );
#endif
    if (!sdl.font)  // Didnt find the font
    {
        printf("Could not load dbfont.ttf, VIRT disabled (%s)", TTF_GetError());
    }
    else
    {
        if (fontsize > 14 ) {
            TTF_SetFontStyle(sdl.font, TTF_STYLE_BOLD );
        }
        else {
            TTF_SetFontStyle(sdl.font, TTF_STYLE_NORMAL );
        }
    }
}

void VIRT_OSD_GFX_Change( void )
{
    if( virt_osd_debug == false && virt_osd_virtkey == false && virt_osd_bufferstate == OSD_STATE_BUFFER )
    {
        SDL_BlitSurface(sdl.blit.surface, NULL,sdl.surface, NULL );
        virt_osd_bufferstate = OSD_STATE_NOBUFFER;
    }
    else if( (virt_osd_debug == true || virt_osd_virtkey == true) && virt_osd_bufferstate == OSD_STATE_NOBUFFER )
    {
        SDL_BlitSurface(sdl.surface, NULL,sdl.blit.surface, NULL );
        virt_osd_bufferstate = OSD_STATE_BUFFER;
    }
}

void VIRT_RefreshScreen( void )
{
    if( sdl.updating == false )
    {
        VIRT_OSD_GFX_Change();
        sdl.updating=true;
        GFX_EndUpdate( NULL );
    }
}

void VIRT_Debug_Toggle(bool pressed)
{
	if (!pressed) return;
	virt_osd_debug=!virt_osd_debug;
	VIRT_RefreshScreen();
}

void VIRT_VirtualKeyboard_Toggle( bool pressed )
{
	if (!pressed) return;
	virt_osd_virtkey=!virt_osd_virtkey;
	if( virt_osd_virtkey ) virt_vk_firstrun = true;
	VIRT_RefreshScreen();
}

int VIRT_VirtualKeyboard( SDL_Event* event )
{
    int intReturnKey = 0;
    bool update_screen = false;
    //Bitu VIRT_key=GetKeyCode(event->key.keysym);
    Bitu VIRT_key=event->key.keysym.sym;
    bool key_state = (event->type == SDL_KEYDOWN) ? true : false;

    // Move to the new position
    if( key_state )
    {
        switch( VIRT_key )
        {
            case SDLK_DOWN:
                virt_row_key++;
                if( virt_row_key >= VIRT_KEYBOARD_ROW ) virt_row_key = 0;

                if( virt_cur_kbd == 1 && virt_row_key == VIRT_ROW_FUNCLABEL ) virt_row_key++; // Dummy labels

                if( virt_row_key == VIRT_ROW_SPECIAL )
                {
                    virt_low_halfrow    = false;
                    virt_up_halfrow     = false;
                    virt_full_row       = true;
                }
                else
                {
                    virt_low_halfrow    = false;
                    virt_up_halfrow     = false;
                    virt_full_row       = false;
                }

                if( (virt_cur_kbd == 0 && ( virt_row_key == VIRT_ROW_SHIFTBACK || virt_row_key == VIRT_ROW_LALTCTRL || virt_row_key == VIRT_ROW_RALTCTRL )) ||
                    (virt_cur_kbd == 1 && ( virt_row_key == VIRT_ROW_INSHOM    || virt_row_key == VIRT_ROW_DELEND   ||
                                            virt_row_key == VIRT_ROW_PGUPGD    || virt_row_key == VIRT_ROW_ESCENTER || virt_row_key == VIRT_ROW_TABPAUSE ||
                                            virt_row_key == VIRT_ROW_FUNCLABEL || virt_row_key == VIRT_ROW_FUNC1112 )) )
                {
                    if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                    {
                        virt_col_key = 0;
                        virt_low_halfrow    = true;
                        virt_up_halfrow     = false;
                        virt_full_row       = false;
                    }
                    else
                    {
                        virt_col_key = VIRT_KEYBOARD_COL/2;
                        virt_low_halfrow    = false;
                        virt_up_halfrow     = true;
                        virt_full_row       = false;
                    }
                }
                update_screen = true;
                break;
            case SDLK_UP:
                virt_row_key--;
                if( virt_row_key < 0 ) virt_row_key = VIRT_KEYBOARD_ROW-1;

                if( virt_cur_kbd == 1 && virt_row_key == VIRT_ROW_FUNCLABEL ) virt_row_key--; // Dummy labels

                if( virt_row_key == VIRT_ROW_SPECIAL )
                {
                    virt_low_halfrow    = false;
                    virt_up_halfrow     = false;
                    virt_full_row       = true;
                }
                else
                {
                    virt_low_halfrow    = false;
                    virt_up_halfrow     = false;
                    virt_full_row       = false;
                }

                if( (virt_cur_kbd == 0 && ( virt_row_key == VIRT_ROW_SHIFTBACK || virt_row_key == VIRT_ROW_LALTCTRL || virt_row_key == VIRT_ROW_RALTCTRL )) ||
                    (virt_cur_kbd == 1 && ( virt_row_key == VIRT_ROW_INSHOM    || virt_row_key == VIRT_ROW_DELEND   ||
                                            virt_row_key == VIRT_ROW_PGUPGD    || virt_row_key == VIRT_ROW_ESCENTER || virt_row_key == VIRT_ROW_TABPAUSE ||
                                            virt_row_key == VIRT_ROW_FUNCLABEL || virt_row_key == VIRT_ROW_FUNC1112 )) )
                {
                    if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                    {
                        virt_col_key = 0;
                        virt_low_halfrow    = true;
                        virt_up_halfrow     = false;
                        virt_full_row       = false;
                    }
                    else
                    {
                        virt_col_key = VIRT_KEYBOARD_COL/2;
                        virt_low_halfrow    = false;
                        virt_up_halfrow     = true;
                        virt_full_row       = false;
                    }
                }
                update_screen = true;
                break;
            case SDLK_RIGHT:
                virt_col_key++;
                if( virt_col_key >= VIRT_KEYBOARD_COL ) virt_col_key = 0;

                if( (virt_cur_kbd == 0 && ( virt_row_key == VIRT_ROW_SHIFTBACK || virt_row_key == VIRT_ROW_LALTCTRL || virt_row_key == VIRT_ROW_RALTCTRL )) ||
                    (virt_cur_kbd == 1 && ( virt_row_key == VIRT_ROW_INSHOM    || virt_row_key == VIRT_ROW_DELEND   ||
                                            virt_row_key == VIRT_ROW_PGUPGD    || virt_row_key == VIRT_ROW_ESCENTER || virt_row_key == VIRT_ROW_TABPAUSE ||
                                            virt_row_key == VIRT_ROW_FUNCLABEL || virt_row_key == VIRT_ROW_FUNC1112 )) )
                {
                    if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                    {
                        virt_col_key = VIRT_KEYBOARD_COL/2;
                        virt_low_halfrow    = false;
                        virt_up_halfrow     = true;
                        virt_full_row       = false;
                    }
                    else
                    {
                        virt_col_key = 0;
                        virt_low_halfrow    = true;
                        virt_up_halfrow     = false;
                        virt_full_row       = false;
                    }
                }
                update_screen = true;
                break;
            case SDLK_LEFT:
                virt_col_key--;
                if( virt_col_key < 0 ) virt_col_key = VIRT_KEYBOARD_COL-1;

                if( (virt_cur_kbd == 0 && ( virt_row_key == VIRT_ROW_SHIFTBACK || virt_row_key == VIRT_ROW_LALTCTRL || virt_row_key == VIRT_ROW_RALTCTRL )) ||
                    (virt_cur_kbd == 1 && ( virt_row_key == VIRT_ROW_INSHOM    || virt_row_key == VIRT_ROW_DELEND   ||
                                            virt_row_key == VIRT_ROW_PGUPGD    || virt_row_key == VIRT_ROW_ESCENTER || virt_row_key == VIRT_ROW_TABPAUSE ||
                                            virt_row_key == VIRT_ROW_FUNCLABEL || virt_row_key == VIRT_ROW_FUNC1112 )) )
                {
                    if( virt_col_key < 0  )
                    {
                        virt_col_key = VIRT_KEYBOARD_COL/2;
                        virt_low_halfrow    = false;
                        virt_up_halfrow     = true;
                        virt_full_row       = false;
                    }
                    else
                    {
                        virt_col_key = 0;
                        virt_low_halfrow    = true;
                        virt_up_halfrow     = false;
                        virt_full_row       = false;
                    }
                }
                update_screen = true;
                break;
            case 0x4f /* NN vol up*/:
                if( fontcolorset == 0 )
                {
                    fontcolor_front++;
                }
                else
                {
                    fontcolor_frontsel++;
                }
                if( fontcolor_front    >= BASIC_COLORS ) fontcolor_front = 0;
                if( fontcolor_frontsel >= BASIC_COLORS ) fontcolor_frontsel = 0;
                update_screen = true;
                break;
            case 0x50 /* NN vol down*/:
	    case SDLK_BACKSPACE:
                if( fontcolorset == 0 )
                if( fontcolorset == 0 )
                {
                    fontcolor_back++;
                }
                else
                {
                   fontcolor_backsel++;
                }
                if( fontcolor_back    >= BASIC_COLORS ) fontcolor_back = 0;
                if( fontcolor_backsel >= BASIC_COLORS ) fontcolor_backsel = 0;
                update_screen = true;
                break;
#if 0
	    case SDLK_BACKSPACE:
                if( fontcolorset == 0 )
                {
                    fontcolorset = 1;
                }
                else
                {
                    fontcolorset = 0;
                }
                break;
#endif
        }
    }

    event->key.keysym.sym = (SDLKey)NULL;

    switch( VIRT_key )
    {
        case 0x32 /* NN down arrow key */:
	case SDLK_ESCAPE:
            if(!key_state && !virt_vk_firstrun) VIRT_VirtualKeyboard_Toggle( true);  // This should close the osd upon releasing the start button
            if( key_state || virt_vk_firstrun ) virt_vk_firstrun = false;
            break;
        case SDLK_TAB:
            if( key_state )
            {
                virt_row_key = 0;
                virt_col_key = 0;

                if( virt_cur_kbd == 0)
                {
                    virt_cur_kbd = 1;
                    virt_low_halfrow    = true;
                    virt_up_halfrow     = false;
                    virt_full_row       = false;
                }
                else
                {
                    virt_cur_kbd = 0;
                    virt_low_halfrow    = false;
                    virt_up_halfrow     = false;
                    virt_full_row       = false;
                }
                update_screen = true;
            }
            break;
        case SDLK_LALT:
            event->key.keysym.sym = SDLK_BACKSPACE;
            break;
        case SDLK_SPACE:
            event->key.keysym.sym = SDLK_SPACE;
            break;
        case SDLK_LSHIFT:
            event->key.keysym.sym = SDLK_RETURN;
            break;
        case 0x4f /* NN vol up*/:
        case 0x50 /* NN vol down*/:
	case SDLK_LCTRL:
            if( virt_cur_kbd == 0 )
            {
                switch( virt_row_key )
                {
                    case VIRT_ROW_SPECIAL:
                        if( key_state )
                        {
                            virt_cur_kbd = 1;

                            virt_row_key = 0;
                            virt_col_key = 0;
                            virt_low_halfrow    = true;
                            virt_up_halfrow     = false;
                            virt_full_row       = false;
                            update_screen = true;
                        }
                        break;
                    case VIRT_ROW_SHIFTBACK:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            if( key_state )
                            {
                                if( virt_shift == false )
                                {
                                    key_state = true;
                                    virt_shift   = true;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_SHIFTBACK][(VIRT_KEYBOARD_COL/2)-1] = 'X';
                                }
                                else
                                {
                                    key_state = false;
                                    virt_shift   = false;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_SHIFTBACK][(VIRT_KEYBOARD_COL/2)-1] = ' ';
                                }
                                update_screen = true;
                                event->key.keysym.sym = SDLK_LSHIFT;
                            }
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_BACKSPACE;
                        }
                        break;
                    case VIRT_ROW_LALTCTRL:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            if( key_state )
                            {
                                if( virt_lalt == false )
                                {
                                    key_state = true;
                                    virt_lalt    = true;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_LALTCTRL][(VIRT_KEYBOARD_COL/2)-1] = 'X';
                                }
                                else
                                {
                                    key_state = false;
                                    virt_lalt    = false;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_LALTCTRL][(VIRT_KEYBOARD_COL/2)-1] = ' ';
                                }
                                update_screen = true;
                                event->key.keysym.sym = SDLK_LALT;
                            }
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            if( key_state )
                            {
                                if( virt_lctrl == false )
                                {
                                    key_state = true;
                                    virt_lctrl   = true;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_LALTCTRL][VIRT_KEYBOARD_COL-1] = 'X';
                                }
                                else
                                {
                                    key_state = false;
                                    virt_lctrl   = false;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_LALTCTRL][VIRT_KEYBOARD_COL-1] = ' ';
                                }
                                update_screen = true;
                                event->key.keysym.sym = SDLK_LCTRL;
                            }
                        }
                        break;
                    case VIRT_ROW_RALTCTRL:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            if( key_state )
                            {
                                if( virt_ralt == false )
                                {
                                    key_state = true;
                                    virt_ralt    = true;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_RALTCTRL][(VIRT_KEYBOARD_COL/2)-1] = 'X';
                                }
                                else
                                {
                                    key_state = false;
                                    virt_ralt    = false;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_RALTCTRL][(VIRT_KEYBOARD_COL/2)-1] = ' ';
                                }
                                update_screen = true;
                                event->key.keysym.sym = SDLK_RALT;
                            }
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            if( key_state )
                            {
                                if( virt_rctrl == false )
                                {
                                    key_state = true;
                                    virt_rctrl   = true;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_RALTCTRL][VIRT_KEYBOARD_COL-1] = 'X';
                                }
                                else
                                {
                                    key_state = false;
                                    virt_rctrl   = false;
                                    virt_keyboard[virt_cur_kbd][VIRT_ROW_RALTCTRL][VIRT_KEYBOARD_COL-1] = ' ';
                                }
                                update_screen = true;
                                event->key.keysym.sym = SDLK_RCTRL;
                            }
                        }
                        break;
                    default:
                        event->key.keysym.sym = (SDLKey)virt_keyboard[virt_cur_kbd][virt_row_key][virt_col_key];
                        break;
                }
            }
            else if( virt_cur_kbd == 1 )
            {
                switch( virt_row_key )
                {
                    case VIRT_ROW_SPECIAL:
                        if( key_state )
                        {
                            virt_cur_kbd = 0;

                            virt_row_key = 0;
                            virt_col_key = 0;
                            virt_low_halfrow    = false;
                            virt_up_halfrow     = false;
                            virt_full_row       = false;
                            update_screen = true;
                        }
                        break;
                    case VIRT_ROW_INSHOM:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_INSERT;
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_HOME;
                        }
                        break;
                    case VIRT_ROW_DELEND:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_DELETE;
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_END;
                        }
                        break;
                    case VIRT_ROW_PGUPGD:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_PAGEUP;
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_PAGEDOWN;
                        }
                        break;
                    case VIRT_ROW_ESCENTER:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_ESCAPE;
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_RETURN;
                        }
                        break;
                    case VIRT_ROW_TABPAUSE:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_TAB;
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_PAUSE;
                        }
                        break;
                    case VIRT_ROW_FUNC1_10:
                        event->key.keysym.sym = (SDLKey)(SDLK_F1+virt_col_key);
                        break;
                    case VIRT_ROW_FUNC1112:
                        if( virt_col_key < VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_F11;
                        }
                        else if( virt_col_key >= VIRT_KEYBOARD_COL/2 )
                        {
                            event->key.keysym.sym = SDLK_F12;
                        }
                        break;
                    default:
                        event->key.keysym.sym = (SDLKey)virt_keyboard[virt_cur_kbd][virt_row_key][virt_col_key];
                        break;
                }
            }
            break;
    }

    if( event->key.keysym.sym != (SDLKey)NULL )
    {
        if( key_state )
        {
            event->type      = SDL_KEYDOWN;
            event->key.state = SDL_PRESSED;
        }
        else
        {
            event->type      = SDL_KEYUP;
            event->key.state = SDL_RELEASED;
        }
        event->key.keysym.scancode   = 0;
        event->key.keysym.mod        = KMOD_NONE;
        event->key.keysym.unicode    = 0;
        intReturnKey = 1;
    }

    if( update_screen == true )
    {
        VIRT_RefreshScreen();
    }

    return intReturnKey;
}

// VIRT fullscreen/scale option

bool virt_noclick        = false;

static void VIRT_NoClick( bool pressed ) {
	if (!pressed) return;
    virt_noclick = !virt_noclick;
}

void GFX_CheckFontSize( void )
{
    if( sdl.surface->w > 320 )
    {
        if( sdl.fontsize != 14 * SDL_GetVideoSurface()->w/320 )
        {
            sdl.fontsize = 14 * SDL_GetVideoSurface()->w/320;
            VIRT_LoadFont( sdl.fontsize );
        }
    }
    else
    {
        if( sdl.fontsize != 14 )
        {
            sdl.fontsize = 14;
            VIRT_LoadFont( sdl.fontsize );
        }
    }
}

// VIRT OSD Draw routine
void GFX_OSD_Debug()
{
	if (sdl.font && virt_osd_debug)
	{
		char fpsdisp[300];
		sprintf(fpsdisp, "%s FPS=%3d PGM=%s", sdl.title, sdl.fps, RunningProgram );
        SDL_Color tcolorfg;
        SDL_Color tcolorbg;
		SDL_Surface *tsurf;

		switch (sdl.desktop.type) {
		case SCREEN_SURFACE:
            tcolorfg = basic_colors[fontcolor_front];
            tcolorbg = basic_colors[fontcolor_back];
            tsurf = TTF_RenderText_Shaded(sdl.font, fpsdisp, tcolorfg, tcolorbg );
			if (tsurf) {
				SDL_SetAlpha(tsurf, 0, 255);
                if( fontcolor_back == 15 )
                {
                    SDL_SetColorKey( tsurf, SDL_RLEACCEL | SDL_SRCCOLORKEY, SDL_MapRGB( tsurf->format, basic_colors[15].r
                                                                                                     , basic_colors[15].g
                                                                                                     , basic_colors[15].b ) );
                }
                else
                {
                    SDL_SetColorKey( tsurf, SDL_RLEACCEL | SDL_SRCCOLORKEY, SDL_MapRGB( sdl.surface->format, basic_colors[15].r
                                                                                                           , basic_colors[15].g
                                                                                                           , basic_colors[15].b )  );
                }
				SDL_BlitSurface(tsurf,NULL,sdl.blit.buffer,NULL);
                SDL_FreeSurface(tsurf);
			}
			break;
		}
	}
}

void GFX_OSD_VirtKey()
{
    char key[2] = { 0x00, 0x00 };
    int intCharWidth = 0, intCharHeight = 0;
    SDL_Color tcolorfg;
    SDL_Color tcolorbg;
    SDL_Surface *tsurf;
    SDL_Rect rectPosition;

	if (sdl.font && virt_osd_virtkey)
	{
        intCharHeight = TTF_FontHeight( sdl.font );
        rectPosition.x = 0;
        rectPosition.y = sdl.surface->h - intCharHeight;

	// Copy to a temporary surface to eliminate flickering
	SDL_BlitSurface( sdl.surface, NULL, sdl.blit.buffer, &sdl.clip );

        // Draw the keyboard
        if( sdl.desktop.type == SCREEN_SURFACE )
        {
            for( int i=VIRT_KEYBOARD_ROW-1; i>=0; i-- )
            {
                for( int j=0; j<VIRT_KEYBOARD_COL; j++ )
                {
                    if( i == virt_row_key && ( j == virt_col_key ||
                                               j <  VIRT_KEYBOARD_COL/2 && virt_low_halfrow == true ||
                                               j >= VIRT_KEYBOARD_COL/2 && virt_up_halfrow  == true ||
                                               virt_full_row == true ) )
                    {
                        tcolorfg = basic_colors[fontcolor_frontsel];
                        tcolorbg = basic_colors[fontcolor_backsel];
                    }
                    else
                    {
                        tcolorfg = basic_colors[fontcolor_front];
                        tcolorbg = basic_colors[fontcolor_back];
                    }

                    if( virt_shift == true && virt_cur_kbd == 0 )
                    {
                        if( virt_keyboard[virt_cur_kbd][i][j] >= 'a' &&
                            virt_keyboard[virt_cur_kbd][i][j] <= 'z' )
                        {
                            key[0] = virt_keyboard[virt_cur_kbd][i][j] - 0x20;
                        }
                        else
                        {
                            switch( virt_keyboard[virt_cur_kbd][i][j] )
                            {
                                case '1':  key[0] = '!'; break;
                                case '2':  key[0] = '@'; break;
                                case '3':  key[0] = '#'; break;
                                case '4':  key[0] = '$'; break;
                                case '5':  key[0] = '%'; break;
                                case '6':  key[0] = '^'; break;
                                case '7':  key[0] = '&'; break;
                                case '8':  key[0] = '*'; break;
                                case '9':  key[0] = '('; break;
                                case '0':  key[0] = ')'; break;
                                case '`':  key[0] = '~'; break;
                                case '-':  key[0] = '_'; break;
                                case '=':  key[0] = '+'; break;
                                case '[':  key[0] = '{'; break;
                                case ']':  key[0] = '}'; break;
                                case ',':  key[0] = '<'; break;
                                case '.':  key[0] = '>'; break;
                                case '/':  key[0] = '?'; break;
                                case ';':  key[0] = ':'; break;
                                case '\\': key[0] = '|'; break;
                                case 0x27: key[0] = '"'; break;
                                default :  key[0] = virt_keyboard[virt_cur_kbd][i][j]; break;
                            }
                        }
                    }
                    else
                    {
                        key[0] = virt_keyboard[virt_cur_kbd][i][j];
                    }

                    tsurf = TTF_RenderText_Shaded(sdl.font, &key[0], tcolorfg, tcolorbg );
                    if( tsurf )
                    {
                        SDL_SetAlpha(tsurf, 0, 255);
                        if( fontcolor_back == 15 || fontcolor_backsel == 15 )
                        {
                            SDL_SetColorKey( tsurf, SDL_RLEACCEL | SDL_SRCCOLORKEY, SDL_MapRGB( tsurf->format, basic_colors[15].r
                                                                                                             , basic_colors[15].g
                                                                                                             , basic_colors[15].b ) );
                        }
                        else
                        {
                            SDL_SetColorKey( tsurf, SDL_RLEACCEL | SDL_SRCCOLORKEY, SDL_MapRGB( sdl.surface->format, basic_colors[15].r
                                                                                                                   , basic_colors[15].g
                                                                                                                   , basic_colors[15].b )  );
                        }
                        SDL_BlitSurface(tsurf, NULL, sdl.blit.buffer, &rectPosition);
                        //SDL_BlitSurface(tsurf, NULL, sdl.surface, &rectPosition);
                        rectPosition.x += tsurf->w;
                        SDL_FreeSurface(tsurf);
                    }
                }
                rectPosition.x = 0;
                rectPosition.y -= intCharHeight;
            }
        }
	}
}
